/*
 File: TS_laasym.cpp
 Date and Time: Mon Jul 28 14:42:05 2008 
*/
#include "TS_laa.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_TS_laa;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_TS_laa::TH_TS_lab(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_TS_lab;
  NS_TS_laa::CTS_lab CTS_lab_;// parallel-parser's parse table
#define ssPARSE_TABLE CTS_lab_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_TS_laa::PROC_TH_TS_lab(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_TS_lab";
  static bool one_time(false);
  static NS_TS_laa::CTS_lab* NS_TS_laa_CTS_lab_(0);// parallel-parser's fsm table
  static Parser* NS_TS_laa_CTS_lab_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_TS_laa_CTS_lab_ = new NS_TS_laa::CTS_lab();// parallel-parser's fsm table
    NS_TS_laa_CTS_lab_parser = new Parser(*NS_TS_laa_CTS_lab_,Caller_pp);
  }
 proc_parser = NS_TS_laa_CTS_lab_parser;
#include "wproc_pp_core.h"
}
void 
CTS_lab::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Recycled_rule_struct* Recycled_rule){
   char a[BUFFER_SIZE];
   int bbb(0);
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_entry_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   int no_entries = rule_entry_tbl_ptr->no_rule_s_entries_;
   Rule_s_reuse_entry* re(0);
   for(;;){
     re = &rule_entry_tbl_ptr->rule_s_reuse_entry_[bbb];
     if(re->rule_on_stk_ == OFF){
       re->rule_on_stk_ = ON;
       Recycled_rule->rule_s_reuse_entry_ = re;
       break;
     }
     ++bbb;
     if(bbb >= no_entries){
      KCHARP msg = "Error ran out of rule recycled entries for %s --- major bug";
      sprintf(a,msg,re->rule_->id());
      Yacco2_faulty_precondition(a,__FILE__,__LINE__);
      exit(1);
     }
   }
   switch (Sub_rule_no){
    case rhs1_Reol_:{
       Reol* sym;
     if(re->rule_ == 0){
       sym = new Reol(parser__);
       Recycled_rule->rule_ = sym;
     }else{
       sym = (Reol*)re->rule_;
       //if ctor present on code sym->reset_ctor();
     }
     sym->rule_info__.rhs_no_of_parms__ = 1;
     return;}
    case rhs1_Rdelimiters_:{
       Rdelimiters* sym;
     if(re->rule_ == 0){
       sym = new Rdelimiters(parser__);
       Recycled_rule->rule_ = sym;
     }else{
       sym = (Rdelimiters*)re->rule_;
       //if ctor present on code sym->reset_ctor();
     }
     sym->rule_info__.rhs_no_of_parms__ = 1;
     return;}
    case rhs2_Rdelimiters_:{
       Rdelimiters* sym;
     if(re->rule_ == 0){
       sym = new Rdelimiters(parser__);
       Recycled_rule->rule_ = sym;
     }else{
       sym = (Rdelimiters*)re->rule_;
       //if ctor present on code sym->reset_ctor();
     }
     sym->rule_info__.rhs_no_of_parms__ = 2;
     return;}
    case rhs3_Rdelimiters_:{
       Rdelimiters* sym;
     if(re->rule_ == 0){
       sym = new Rdelimiters(parser__);
       Recycled_rule->rule_ = sym;
     }else{
       sym = (Rdelimiters*)re->rule_;
       //if ctor present on code sym->reset_ctor();
     }
     sym->rule_info__.rhs_no_of_parms__ = 2;
     return;}
    default: return;
   }
}
